#! /usr/bin/perl
##########################################################################
# SimpleSubmit!
  $script_version = "2.2";
  $last_modified = "07/01/99";
# Copyright, 1999 Jason M. Hinkle
# http://www.verysimple.com/scripts/simplesubmit.html
# Modified on 4/18/99 while listening to Fat Boy Slim
#
# LEGAL DISCLAIMER:
# This software is provided as-is.  Use it at your own risk.  The
# author takes no responsibility for any damages or losses directly
# or indirectly caused by this software.  This software may be 
# modified and distributed as long as this comment and copyright
# section is included.
##########################################################################

# CONFIGURATION VARIABLES:

# @referers is a list of domains that can use this script.  Enter as
# many as you'd like, separated by commas.  If you prefer to let anyone
# use this script and not check the domain, then simply comment this line
# out by placing a # in front of it.

#    @referers = ('www.verysimple.com','verysimple.com');

# $script_url is the URL to the script so that it can refer to itself.
# this line only needs to be modified if you changed the name of the 
# script or are getting 404 errors when running it.

    $script_url = "./submit.cgi";
 
# $dat_location is the path to the dat file.  This line only needs
# to be modified if you changed the name of the submit.dat file.

    $dat_location = "./submit.dat";

# OPTIONAL CONFIGURATION VARIABLES:

# $sendmail defines the location of your sendmail program on your
# server.  Type 'which sendmail' at the UNIX prompt or ask your
# administrator if you don't know.

    $sendmail = '/usr/sbin/sendmail';

# $thank_you is a file that contains the custom thank you message
# that will be sent to the user.  This does not need to be changed
# unless you renamed submit.tha.

    $thank_you = './submit.tha';

# END OF CONFIGURATION VARIABLES
##########################################################################

# Check refering URL.
&check_referer if (@referers);

# Load in the DAT file
&load_datfile($dat_location);

# Parse input
&read_parse();

# Check for valid input
&check_input;

# Get the URLS from the DAT file
&get_urls;

# Determine the output based on the action variable and send
# it to the browser.
&output(&get_output($in{action}));


# ---------------------------------------------------------------------------
# check_referer v1.0
# Based on check_referer, Copyright (c) 1997 Matt Wright
# 
# Requires &script_error
# ---------------------------------------------------------------------------
sub check_referer {

    # Localize the check_referer flag which determines if user is valid.     #
    local($check_referer) = 0;

    # If a referring URL was specified, for each valid referer, make sure    #
    # that a valid referring URL was passed to FormMail.                     #

    if ($ENV{'HTTP_REFERER'}) {
        foreach $referer (@referers) {
            if ($ENV{'HTTP_REFERER'} =~ m|https?://([^/]*)$referer|i) {
                $check_referer = 1;
                last;
            }
        }
    }
    else {
        $check_referer = 2;
    }

    # If the HTTP_REFERER was invalid, send back an error.                   #
    if ($check_referer != 1) { &script_error('ERROR: Your domain is not authorized to use this script.') }
}


# ---------------------------------------------------------------------------
# load_datfile v1.0
# Copyright (c) 1998 Jason M. Hinkle
# http://www.verysimple.com/scripts/
# 
# Requires &script_error
# ---------------------------------------------------------------------------
sub load_datfile {
    local ($library_name) = @_ if @_;

    if (-e "$library_name") {
        if (-r "$library_name") {
            require "$library_name";
        } else {
            # DAT file is not readable
            $dat_version = "Unknown";
            &script_error('ERROR: DAT file is not readable.');
        }        
    } else {
        # DAT file is not found
        $dat_version = "Unknown";
        &script_error('ERROR: DAT file was not found.');
    }
    

}


# ---------------------------------------------------------------------------
# check_input v1.0
# 
# Requires &script_error
# ---------------------------------------------------------------------------
sub check_input {

    if ($in{action} eq '') {
        &script_error('')
    }

    # $form_url is the URL to the form for the return link.
    # If referer was submited, then make that the return link,
    # otherwise, use the refering page
    if ($in{referer}) {
        $form_url = $in{referer};
    } else {
        $form_url = $ENV{'HTTP_REFERER'};
    }

    if ($in{action} eq 'confirm' || $in{action} eq 'submit') {
        &script_error('ERROR: You must enter a valid URL!') if ($in{url} eq '' || $in{url} eq 'http://');
        if (&check_email($in{email})) {
            # email address is ok
        } else {
            &script_error('ERROR: You must enter an valid email address!')
        }
    }
    
}


# ---------------------------------------------------------------------------
# get_output v1.0
# Copyright 1998, Jason M. Hinkle
# http://www.verysimple.com/scripts
# ---------------------------------------------------------------------------
sub get_output {
    local($action) = @_;
    local(@engines, $num_engines, $left_engine, $right_engine);
    local($left_frame, $right_frame, $num_frames, $frame_percent);


   # $pass_through will be used later if the method is post to pass through all the variables
   # that were sent to the script.  $section is delt with separtately because of some screwed
   # up feature/glitch with browsers that causes &sect to be converted into some wing-ding 
   # character and f--- everything up.
    foreach $key (keys(%in)) {
        if ($in{$key} && $key ne "action" && $key ne "engines" && $key ne "thankyou" && $key ne "section") {
            $pass_through .=  "\&" . $key . "=" . $in{$key} if $in{$key};
        }
    }
    $pass_through .=  "&ss_section=" . $in{'section'} if $in{'section'};

    if ($action eq "submit") {
        # Check to see if any search engines were selected.  If not
        # use the default defined in the DAT file.  Split the choices
        # into an array.
        if ($in{engines}) {
            @engines = split(/\0/,$in{engines})
        } else {
            @engines = split(/\0/,$default_engines)
        }

        # Figure out how may engines were selected.  Add the
        # bannerframe and increase the number by one.
        $num_engines = @engines;
        $engines[$num_engines] = "bannerframe";
        $num_engines++;

        # See if there are an odd number of frames.  If there is, 
        # make the empty frame "oddframe" specified in the DAT file.
        if ($num_engines % 2) {
            $engines[$num_engines] = "oddframe";
            $num_engines++;
        }

        # Figure out how may frames to make and how big they are
        $num_frames = $num_engines/2;
        $frame_percent = 100/$num_frames;

        # Print out the FRAMESET tag.  Since we don't know how many
        # frames there are going to be, we just make a loop...
        $output = "<frameset rows=\"";
        for ($frame_count = 0; $frame_count < ($num_frames); $frame_count++) {
            $output .= "$frame_percent\%";
            if ($frame_count != ($num_frames-1)){
                $output .= ", ";
            }
        }
        $output .= "\" border=1>\n";

        # Now we print out the actual frames.  Same loop as above.
        for ($frame_count = 0; $frame_count < ($num_frames); $frame_count++) {

            # Handy formula to figure out which frame we're on
            $left_frame = ((($frame_count +1) * 2) -1);
            $right_frame = $left_frame + 1;

            # Grab the appropriate frame title out of the engines array,
            $left_engine = $engines[($left_frame - 1)];
            $right_engine = $engines[($right_frame - 1)];

            # use the engines array value to pull out the actual URL
            # from the associative array $url.
            # Check to see if this is blank in
            # case the form has an engine that isn't specified in
            # the DAT file.
            if ($url{$left_engine} eq "") {$left_engine = "errorframe"}
            if ($url{$right_engine} eq "") {$right_engine = "errorframe"}

            $left_url = $url{$left_engine};
            $right_url = $url{$right_engine};

            # now let's see if the method is supposed to be post instead of get,
            # if so, we'll just write over what is already there and send it back
            # into the script to make a neato little post button.

            if ($method{$left_engine} eq "post") {
                $left_url = $script_url . "?action=post&engine=" . $left_engine . $pass_through;
            }

            if ($method{$right_engine} eq "post") {
                $right_url = $script_url . "?action=post&engine=" . $right_engine . $pass_through;
            }

            # return("url=" . $url{$left_engine} . "<p>method=" . $method{$left_engine} . "<p>left:" .  $left_engine . "<P>right:" . $right_engine);

            $output .= "<frameset cols=\"50%,50%\" border=1>\n";
            $output .= "<frame name=\"$left_frame\" src=\"$left_url\" marginwidth=\"0\" marginheight=\"0\" scrolling=\"auto\" frameborder=\"yes\" noresize>\n";
            $output .= "<frame name=\"$right_frame\" src=\"$right_url\" marginwidth=\"0\" marginheight=\"0\" scrolling=\"auto\" frameborder=\"yes\" noresize>\n";
            $output .= "</frameset>\n";
        }


        $output .= "\n";
        $output .= "<noframes>\n";
        $output .=  "<body bgcolor=\"#FFFFFF\" LINK=\"Blue\" ALINK=\"Teal\" VLINK=\"Blue\" text=\"Navy\">\n";
        $output .= "<font size=\"4\" face=\"arial,helvetica\">\n";
        $output .= "<b>SIMPLESUBMIT!</b>\n";
        $output .= "</font>\n";
        $output .= "<p>\n";
        $output .= "<b>Your Browser Does Not Support Frames!</b>\n";
        $output .= "<p>\n";
        $output .= "To use the full functionallity of SimpleSubmit!, you should have\n";
        $output .= "a browser that supports frames such as Netscape or MS Explorer.\n";
        $output .= "You can still submit your URL to one search engine at a time by clicking\n";
        $output .= "each of the links below, then returning to this screen to click\n";
        $output .= "the next link:\n";
        $output .= "<p>\n";
 
        if ($in{engines}) {
            @engines = split(/\0/,$in{engines})
        } else {
            @engines = split(/\0/,$default_engines)
        }

        foreach $engine (@engines) {
            if ($url{$engine}) {
                if ($method{$engine} eq "post") {
                    $output .= "<form action=\"$url{$engine}\" method=\"post\">\n";
                    # Pass along all the variables that were sent into the script
                    foreach $key (%in) {
                        if ($in{$key} && $key ne "action" && $key ne "engines" && $key ne "thankyou") {
                            $output .=  "<input type=\"Hidden\" name=\"$key\" value=\"$in{$key}\">\n";
                        }
                    }
                    $output .= "<input type= \"submit\" value=\"submit to $engine\">\n";
                    $output .= "</form>\n";

                } else {
                    $output .= "<a href=\"$url{$engine}\">submit to $engine</a><br>\n";
                }
            } else {
                $output .= "Engine: $engine is not defined in the DAT file.<br>\n";
            }
        }

        $output .= "<p>\n";
        $output .= "<b><a href=\"$form_url\">Submit Another Site!</a></b><br>\n";
        $output .= "</body>\n";
        $output .= "</noframes>\n";

        $output .= "\n";
        $output .= "</frameset>\n";

        return $output;
    }    

    if ($action eq "confirm") {
        # Output the confirmation screen
        $output =  "<body bgcolor=\"#FFFFFF\" LINK=\"Blue\" ALINK=\"Teal\" VLINK=\"Blue\" text=\"Navy\">\n";
        $output .=  "<font size=\"4\" face=\"arial,helvetica\">\n";
        $output .=  "<b>SIMPLESUBMIT! CONFIRMATION PAGE:</b>\n";
        $output .=  "</font>\n";
        $output .=  "<p>\n";
        $output .=  "<font face=\"arial,helvetica\">\n";
        $output .=  "<b>You submitted the following:</b>\n";
        $output .=  "<p>\n";
        $output .=  "<form action=\"$script_url\" method=\"POST\">\n";
        $output .=  "<table border=1 cellspacing=0 cellpadding=3>\n";

        # Pass along all the variables that were sent into the script
        foreach $key (%in) {
            if ($in{$key} && $key ne "action" && $key ne "engines" && $key ne "thankyou") {
                $output .=  "<tr>\n";
                $output .=  "<td><b>$key:</b></td>\n";
                $output .=  "<td>$in{$key}</td>\n";
                $output .=  "<input type=\"Hidden\" name=\"$key\" value=\"$in{$key}\">\n";
                $output .=  "</tr>\n";
            }
        }

        # Get all the engine names and print those
        if ($in{engines}) {
            @engines = split(/\0/,$in{engines})
        } else {
            @engines = split(/\0/,$default_engines)
        }
        $output .=  "<tr>\n";
        $output .=  "<td><b>engines:</b></td>\n";
        $output .=  "<td>\n";

        foreach $engine_name (@engines) {
            $output .=  "$engine_name";
            $output .=  "<input type=\"Hidden\" name=\"engines\" value=\"$engine_name\">\n";
        }
        $output .=  "</td>\n";
        $output .=  "</tr>\n";

        $output .=  "</table>\n";

        # print out the thankyou variable
        $output .=  "<input type=\"Hidden\" name=\"thankyou\" value=\"$in{thankyou}\">\n";

        # print out the referring page for the link back
        $output .=  "<input type=\"Hidden\" name=\"referer\" value=\"$ENV{'HTTP_REFERER'}\">\n";

        # print out the action variable, which is now 'submit'
        $output .=  "<input type=\"Hidden\" name=\"action\" value=\"submit\">\n";
        $output .=  "<p>\n";
        $output .=  "<input type=\"Submit\" value=\"Correct!  Submit My Site.\">\n";
        $output .=  "</form>\n";
        $output .=  "<p>\n";
        $output .=  "<i>If the information above is not correct, please use the \n";
        $output .=  "back button on your browser to return to the previous screen \n";
        $output .=  "and edit your submission.</i>\n";
        $output .=  "</font>\n";
        $output .=  "<p>\n";
        $output .=  "<font face=\"Arial, Helvetica\" size=\"2\">\n";
        $output .=  "------------------------------------<br>\n";
        $output .=  "<b>SimpleSubmit $script_version</b><br>\n";
        $output .=  "DAT version: $dat_version<br>\n";
        $output .=  "\&copy; 1998, Jason M. Hinkle<br>\n";
        $output .=  "<a href=\"http://www.verysimple.com/scripts/simplesubmit.html\">http://www.verysimple.com/scripts/simplesubmit.html</a><br>\n";
        $output .=  "</font>\n";
        $output .=  "</body>\n";
        return $output;
    }    

    if ($action eq "oddframe") {
        $output =   "<body bgcolor=\"\#8080C0\" marginwidth=5 marginheight=5 leftmargin=5 topmargin=5>\n";
        $output .=  "<font face=\"Arial, Helvetica\" size=\"4\">\n";
        $output .=  "<b><a href=\"http://www.verysimple.com/scripts/simplesubmit.html\" target=\"_top\">SimpleSubmit!</a></b>\n";
        $output .=  "<p>\n";
        $output .=  "</font>\n";
        $output .=  "<font face=\"Arial, Helvetica\" size=\"2\">\n";
        $output .=  "Do you like this script?  There's plenty more where this\n";
        $output .=  "one came from.  Visit VerySimple Scripts at:\n";
        $output .=  "<b><a href=\"http://www.verysimple.com/scripts/simplesubmit.html\" target=\"_top\">http://www.verysimple.com/scripts/</a></b><br>\n";
        $output .=  "</font>\n";
        $output .=  "</body>\n";
        return $output;
    }

    if ($action eq "errorframe") {
        $output =   "<body bgcolor=\"\#FF0000\" marginwidth=5 marginheight=5 leftmargin=5 topmargin=5>\n";
        $output .=  "<font face=\"Arial, Helvetica\" size=\"4\">\n";
        $output .=  "<b>OOOOPS!</b>\n";
        $output .=  "<p>\n";
        $output .=  "</font>\n";
        $output .=  "<font face=\"Arial, Helvetica\" size=\"2\">\n";
        $output .=  "There was an error submitting this search\n";
        $output .=  "engine.  The form may be set up incorrectly, or\n";
        $output .=  "you may need to upgrade your DAT file.  For more\n";
        $output .=  "information, visit VerySimple Scripts at:\n";
        $output .=  "<b><a href=\"http://www.verysimple.com/scripts/simplesubmit.html\" target=\"_top\">http://www.verysimple.com/scripts/</a></b><br>\n";
        $output .=  "</font>\n";
        $output .=  "</body>\n";
        return $output;
    }

    if ($action eq "post") {
        $output =   "<body bgcolor=\"#ccff00\" marginwidth=5 marginheight=5 leftmargin=5 topmargin=5 onload=\"JavaScript:document.simplesubmit.submit()\">\n";
        $output .=  "<form name=\"simplesubmit\" action=\"$url{$in{'engine'}}\" method=\"post\">\n";
        # Pass along all the variables that were sent into the script
        foreach $key (%in) {
            if ($in{$key} && $key ne "engine" && $key ne "action" && $key ne "ss_section") {
                $output .=  "<input type=\"Hidden\" name=\"$key\" value=\"$in{$key}\">\n";
            }
        }
        $output .=  "<input type=\"Hidden\" name=\"section\" value=\"$in{'ss_section'}\">\n" if $in{'ss_section'};
        $output .=  "<input type=\"submit\" value=\"post to $in{'engine'}\">\n";
        $output .=  "</form>\n";
        $output .=  "</body>\n";
        return $output;
    }

    # If we get this far, we've encountered an action that is not
    # defined.  This is only possible if the form is not set up
    # right, so the error message is not as pretty.
    return "<b>ERROR: action: $action is not defined.</b>";
}


sub check_email {
    # Initialize local email variable with input to subroutine.              #
    $email = $_[0];

    # If the e-mail address contains:                                        #
    if ($email =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)/ ||

        # the e-mail address contains an invalid syntax.  Or, if the         #
        # syntax does not match the following regular expression pattern     #
        # it fails basic syntax verification.                                #

        $email !~ /^.+\@(\[?)[a-zA-Z0-9\-\.]+\.([a-zA-Z]{2,3}|[0-9]{1,3})(\]?)$/) {

        # Basic syntax requires:  one or more characters before the @ sign,  #
        # followed by an optional '[', then any number of letters, numbers,  #
        # dashes or periods (valid domain/IP characters) ending in a period  #
        # and then 2 or 3 letters (for domain suffixes) or 1 to 3 numbers    #
        # (for IP addresses).  An ending bracket is also allowed as it is    #
        # valid syntax to have an email address like: user@[255.255.255.0]   #

        # Return a false value, since the e-mail address did not pass valid  #
        # syntax.                                                            #
        return 0;
    }

    else {

        # Return a true value, e-mail verification passed.                   #
        return 1;
    }
}


# ---------------------------------------------------------------------------
# send_email v1.0
# Copyright (c) 1998 Jason M. Hinkle
# http://www.verysimple.com/scripts/
# ---------------------------------------------------------------------------
sub send_email {

    if ($in{'action'} eq "submit" && $in{'thankyou'}) {
        # Open The Mail Program
        open(MAIL,"|$sendmail -t");

		if (-r "$thank_you") {
	        open(BODY, "$thank_you");
	        @body = <BODY>;
	        close(BODY);
		} else {
			$body[0] = "From: SimpleSubmit\@verysimple.com\n";
			$body[1] = "Subject: Thank You from SimpleSubmit!\n\n";
			$body[2] = "Thank you for using SimpleSubmit!\n\n";
			$body[3] = "Your URL: $in{'url'} ";
			$body[4] = "has been submitted.\n\n";
			$body[5] = "If you found this free resource useful, please consider rating it\n";
			$body[6] = "with cgi-resources. Visit us at http://www.verysimple.com/submit/\n";
			$body[7] = "to rate the script or to submit another URL.\n\n";
			$body[8] = "Sincerely,\n";
			$body[9] = "The SimpleSubmit Team at VerySimple\n";
		}

        print MAIL "To: $in{'email'}\n";

        foreach $body (@body) {
            print MAIL "$body";
        }

        close (MAIL);
    }
}


# ---------------------------------------------------------------------------
# read_parse v1.2
# Copyright (c) 1998 Jason M. Hinkle
# http://www.verysimple.com/scripts/
# Based on ReadParse v1.14, Copyright (c) 1995 Steven E. Brenner
# Reads in GET, POST or UNIX command line data
# 
# See configuration variable (below) to accept command line input.
# ---------------------------------------------------------------------------
sub read_parse {
  # check if an alternate name is use and localize variables
  local (*in) = @_ if @_;
  local ($i, $key, $val, $accept_command);

  # Global variables returned: $in{field_name}, $method

  # -----------------------------------------------------------------------
  # CONFIGURATION VARIABLE FOR READ_PARSE:
  # -----------------------------------------------------------------------
  # $accept_command = 1 (to accept command line input) or
  # $accept_command = 0 (to block command line input)
  $accept_command = 0;

  # $rp_delimiter is the character(s) that is inserted between values when
  # there is more than one value per variable - like a multiple select box.
  $rp_delimiter = "\0";

  # set some global variables
  $method = $ENV{'REQUEST_METHOD'};
  $length  = $ENV{'CONTENT_LENGTH'};

  # determine the request method and read in the text
  
  # check to see if command line data was entered
  if (!defined $method || $method eq '') {
    if ($accept_command) {
        push(@in, @ARGV);
        $method = "COMMAND";  # also use command-line options
    } else {
        die("ERROR: Command line input not accepted\n")
    }
  
  # check to see if data was submitted via GET
  } elsif($method eq 'GET' || $method eq 'HEAD') {
    $in = $ENV{'QUERY_STRING'};
    @in = split(/[&;]/,$in);
  
  # check to see if data was submitted via POST
  } elsif ($method eq 'POST') {
    if (($got = read(STDIN, $in, $length) != $length)) {
      $errflag="Short Read: wanted $length, got $got\n"
    };
    @in = split(/[&;]/,$in);
  
  # otherwise, what the...?
  } else {
    $errflag="Unknown request method: $method\n";
  }

  # Change all the funky characters back to english and assign the variables
  foreach $i (0 .. $#in) {
    # Convert plus's to spaces
    $in[$i] =~ s/\+/ /g;

    # Split into key and value.
    ($key, $val) = split(/=/,$in[$i],2); # splits on the first =.

    # Convert %XX from hex numbers to alphanumeric
    $key =~ s/%(..)/pack("c",hex($1))/ge;
    $val =~ s/%(..)/pack("c",hex($1))/ge;

    # Associate key and value
    $in{$key} .= $rp_delimiter if (defined($in{$key}));
    $in{$key} .= $val;

  }

  # return the variables using the array name given, or @in
  return scalar(@in);
}


# ---------------------------------------------------------------------------
# output (simplesubmit version 1.0)
# Copyright (c) 1998 Jason M. Hinkle
# http://www.verysimple.com/scripts/
# ---------------------------------------------------------------------------
sub output {
    local($message) = @_;

    print "Content-type: text/html\n\n";
    print "<html>\n";
    print "<head>\n";
    print "<title>SimpleSubmit!</title>\n";
    print "</head>\n";

    print "$message\n";

    print "</html>\n";

    # Send thank-you message - This call is made after the HTML
    # is already out, just before the script ends to speed things
    # up for the user.  The routine determines whether or not the
    # message should be sent based on $action and $thankyou
    &send_email;

    exit;
}

# ---------------------------------------------------------------------------
# script_error (simplesubmit version 1.0)
# Copyright (c) 1998 Jason M. Hinkle
# http://www.verysimple.com/scripts/
# ---------------------------------------------------------------------------
sub script_error {
    local($error) = @_;
  
    print "Content-type: text/html\n\n";
    print "<html>\n";
    print "<head>\n";
    print "<title>SimpleSubmit!</title>\n";
    print "</head>\n";
    print "<body bgcolor=\"#FFFFFF\">\n";
    print "<font face=\"Arial, Helvetica\" size=\"4\" color=\"Red\"><b>\n";

    print "$error\n";

    print "</b></font>\n";
    print "<p>\n";
    print "<font face=\"Arial, Helvetica\" size=\"2\">\n";
    print "<p><hr noshade><p>\n" if $error;
    print "<b>SimpleSubmit $script_version</b><br>\n";
    print "DAT version: $dat_version<br>\n";
    print "\&copy; 1998, Jason M. Hinkle<br>\n";
    print "<a href=\"http://www.verysimple.com/scripts/simplesubmit.html\">http://www.verysimple.com/scripts/simplesubmit.html</a><br>\n";
    print "</font>\n";
    print "</body>\n";
    print "</html>\n";
    exit;
}